<?php
$edition_list = Array('freedev' => 'FreeDev',
			'small' => 'ProDev - Basic',
			'smedium' => 'ProDev - Developer',
			'medium' => 'ProDev - Business',
			'large' => 'ProDev - Enterprise');

$conn_list = Array('inc_email' => 'Incoming Email',
		'inline_entity' => 'Inline Entity',
		'calendar' => 'Calendar',
		'rating' => 'Rating',
		'woocommerce' => 'WooCommerce',
		'edd' => 'Easy Digital Downloads',
		'youtube_api' => 'YouTube');


function wpas_licenses_page(){
	echo '<div class="wpas">';
	wpas_branding_header();
	echo wpas_display_licenses_page();
	wpas_branding_footer();
	echo '</div>';
}	
function wpas_display_licenses_page(){
	$licenses = get_option('wpas_licenses',Array());
	$license_status = get_option('wpas_license_status',Array());
	?>
		<div id="was-container" class="container-fluid">
		<ul class="breadcrumb">
		<li id="first">
		<a href="<?php echo admin_url('admin.php?page=wpas_app_list'); ?>">
		<i class="icon-home"></i><?php _e("Home","wp-app-studio"); ?></a>
		<span class="divider">/</span>
		</li>
		<li id="second" class="inactive"><?php _e("Licenses","wp-app-studio"); ?></li>
		</ul>
		<div class="row-fluid">
		<form method="post" action="options.php">
		<div class="well">
		<h3><?php _e("Plan License","wp-app-studio"); ?></h3>
		<p><?php printf(__('Please enter and activate your <b>license key</b>. If you don\'t have a license key join a <a href="%s" target="_blank">WPAS development edition plan</a>.','wp-app-studio'),WPAS_URL . '/wp-app-studio-pricing/?pk_campaign=wpas&pk_source=plugin&pk_medium=link&pk_content=join'); ?> 
		<table class="form-table">
		<tbody>
		<?php
		settings_fields('wpas_licenses');
		wpas_show_ed_license($licenses,$license_status);
?>
		</tbody>
		</table>
		</div>
		<div class="well">
		<h3><?php _e("Connection Licenses","wp-app-studio"); ?></h3>
<p><?php printf(__('If your plan does not support <a href="%s" target="_blank">WPAS connections</a>, you need to purchase a connection license key and enter it below as well to be able to use that connection in your designs.', 'wp-app-studio'), WPAS_URL . '/connections/?pk_campaign=wpas&pk_source=plugin&pk_medium=link&pk_content=connections'); ?>
		<p><a href="<?php echo esc_url(admin_url('admin.php?page=wpas_licenses_page&add=license')); ?>" class="btn btn-info"><?php _e('Add a license key','wp-app-studio'); ?></a></p>
		<table class="form-table">
		<tbody>
		<?php
		$count_lic = 0;
		if(!empty($licenses['connection'])){
			$count_lic = count($licenses['connection']);
		}
                $i = 1;
		if($count_lic == 0){
			wpas_show_conn_license_row('',$i,$license_status);
		}
		elseif($count_lic > 0){
                	foreach($licenses['connection'] as $key => $val){
                        	wpas_show_conn_license_row($val,$i,$license_status);
                        	$i++;
			}
                }
		if($count_lic != 0 && !empty($_GET['add']) && $_GET['add'] == 'license'){
			$last = $count_lic + 1;
			wpas_show_conn_license_row('',$last,$license_status);
		}
	?>
		</tbody>
		</table>
		</div>
	<?php
	submit_button(__('Save','wp-app-studio')); ?>
		</form>
		</div>
		</div>

		<?php
}
function wpas_show_ed_license($licenses,$license_status){
	$error = get_option('wpas_license_error',Array());
	global $edition_list;
	$select_ed_conn = '<select id="wpas_license_name" name=wpas_licenses[edition][name]">';
	if(!empty($edition_list)){
		foreach($edition_list as $eckey => $ecval){
			$select_ed_conn .= '<option value="' . $eckey . '"';
			if(!empty($licenses) && !empty($licenses['edition']) && $licenses['edition']['name'] == $eckey){
				$select_ed_conn .= ' selected';
			}
			$select_ed_conn .= '>' . $ecval . '</option>';
		}
	}
	$select_ed_conn .= '</select>';
	?>
	<tr>
	<th scope="row">
	<?php echo $select_ed_conn; ?>
	</th>
	<td>
	<input id="wpas_license_key" name="wpas_licenses[edition][key]" type="text" class="input-xlarge" value="<?php echo (!empty($licenses['edition'])) ? esc_attr($licenses['edition']['key']) : ''; ?>" />
		<?php 
		if (!empty($licenses['edition']) && !empty($licenses['edition']['key'])) {
			$status = (!empty($license_status[$licenses['edition']['key']]['status'])) ? $license_status[$licenses['edition']['key']]['status'] : 'inactive'; 
			if($status == 'inactive'){
				$status_color = 'red';
			}
			elseif($status == 'deactivated'){
				$status_color = '#8a6d3b';
			}
			?>
			<input type="hidden" id="<?php echo $licenses['edition']['key'] . '_wpas_license_status';?>" name="<?php echo $licenses['edition']['key'] . '_wpas_license_status';?>" value="<?php echo $status;?>">
		<?php if ($status == 'valid') { 
			wp_nonce_field($licenses['edition']['key'] . '_wpas_license_nonce', $licenses['edition']['key'] . '_wpas_license_nonce'); ?>
			<input type="submit" class="button-secondary" name="<?php echo $licenses['edition']['key'];?>_wpas_license_deactivate" value="<?php _e('Deactivate License', 'wp-app-studio'); ?>"/>
			<span style='color:#228b22;font-weight:500;'><?php echo strtoupper($status) . '&nbsp;'; ?><h3 style="display:inline">&check;</h3></span>
		<?php
		} else {
			wp_nonce_field($licenses['edition']['key'] . '_wpas_license_nonce', $licenses['edition']['key'] . '_wpas_license_nonce');  ?>
			<input type="submit" class="button-secondary" name="<?php echo $licenses['edition']['key'];?>_wpas_license_activate" value="<?php _e('Activate License', 'wp-app-studio'); ?>"/>
			<span style='color:<?php echo $status_color; ?>;font-weight:500;'><?php echo strtoupper($status) . '&nbsp;'; ?><h3 style="display:inline">&#x2691;</h3></span>
			<?php
		}
	}
	if(!empty($error) && !empty($licenses['edition']) && !empty($error[$licenses['edition']['key']])){
		echo "<div style='padding:5px;'><span style='color:red;font-weight:500;background-color:white;'>" . __('Error:','wp-app-studio') . '&nbsp;' . $error[$licenses['edition']['key']] . "</span></div>";
	}
	?>
	</td>
	</tr>
<?php
}
function wpas_show_conn_license_row($license_row,$rcount,$license_status){
	$error = get_option('wpas_license_error',Array());
	global $conn_list;
	$select_ed_conn = '<select id="wpas_license_con_name" name=wpas_licenses[connection][' . $rcount . '][name]">';
	if(!empty($conn_list)){
		foreach($conn_list as $eckey => $ecval){
			$select_ed_conn .= '<option value="' . $eckey . '"';
			if(!empty($license_row) && $license_row['name'] == $eckey){
				$select_ed_conn .= ' selected';
			}
			$select_ed_conn .= '>' . $ecval . '</option>';
		}
	}
	$select_ed_conn .= '</select>';
	?>
	<tr>
	<th scope="row">
	<?php echo $select_ed_conn; ?>
	</th>
	<td>
	<input id="wpas_license_con_key" name="wpas_licenses[connection][<?php echo $rcount;?>][key]" type="text" class="input-xlarge" value="<?php echo (!empty($license_row)) ? esc_attr($license_row['key']) : ''; ?>" />
		<?php 
		if (!empty($license_row) && !empty($license_row['key'])) {
			$status = (!empty($license_status[$license_row['key']]['status'])) ? $license_status[$license_row['key']]['status'] : 'inactive'; 
			if($status == 'inactive'){
				$status_color = 'red';
			}
			elseif($status == 'deactivated'){
				$status_color = '#8a6d3b';
			}
			?>
			<input type="hidden" id="<?php echo $license_row['key'] . '_wpas_license_status';?>" name="<?php echo $license_row['key'] . '_wpas_license_status';?>" value="<?php echo $status;?>">
		<?php if ($status == 'valid') { 
			wp_nonce_field($license_row['key'] . '_wpas_license_nonce', $license_row['key'] . '_wpas_license_nonce'); ?>
			<input type="submit" class="button-secondary" name="<?php echo $license_row['key'];?>_wpas_license_deactivate" value="<?php _e('Deactivate License', 'wp-app-studio'); ?>"/>
			<span style='color:#228b22;font-weight:500;'><?php echo strtoupper($status) . '&nbsp;'; ?><h3 style="display:inline">&check;</h3></span>
		<?php
		} else {
			wp_nonce_field($license_row['key'] . '_wpas_license_nonce', $license_row['key'] . '_wpas_license_nonce');  ?>
			<input type="submit" class="button-secondary" name="<?php echo $license_row['key'];?>_wpas_license_activate" value="<?php _e('Activate License', 'wp-app-studio'); ?>"/>
			<span style='color:<?php echo $status_color; ?>;font-weight:500;'><?php echo strtoupper($status) . '&nbsp;'; ?><h3 style="display:inline">&#x2691;</h3></span>
			<?php
		}
	}
	if(!empty($error) && !empty($license_row) && !empty($error[$license_row['key']])){
		echo "<div style='padding:5px;'><span style='color:red;font-weight:500;background-color:white;'>" . __('Error:','wp-app-studio') . '&nbsp;' . $error[$license_row['key']] . "</span></div>";
	}
	?>
	</td>
	</tr>
<?php
}
add_action( 'admin_init', 'wpas_license_register');

/**
 * Register license settings option
 *
 * @since WPAS 5.0
 *
 */
function wpas_license_register(){
        if ( false == get_option( 'wpas_licenses' ) ) {
                add_option( 'wpas_licenses' );
        }
        register_setting('wpas_licenses','wpas_licenses','wpas_sanitize_license');
}

/**
 * Sanitize license settings
 *
 * @since WPAS 5.0
 * @param array $new
 *
 * @return array $new
 */
function wpas_sanitize_license($new){
	if(!empty($new)){
		if(!empty($new['edition']) && (empty($new['edition']['key']) || empty($new['edition']['name']))){
			unset($new['edition']);
		}
		if(!empty($new['connection'])){
			foreach($new['connection'] as $klic => $lics){
				if(empty($lics['key']) || empty($lics['name'])){
					unset($new['connection'][$klic]);
				}
			}
		}
	}
	return $new;
}

add_action( 'admin_init', 'wpas_activate_deactivate_license');
/**
 * Activate/Deactivate license api 
 * @since WPAS 5.0
 *
 */
function wpas_activate_deactivate_license() {
        if(!isset($_POST['wpas_licenses'])) return;
        if(isset($_POST['submit'])) return;
	global $edition_list, $conn_list;
	$edition_conn_list = array_merge($edition_list,$conn_list);
	$mylicense = Array();
        $license_action = "";
        $licenses = get_option('wpas_licenses');
        $license_status = get_option('wpas_license_status');
	if(!empty($licenses) && !empty($licenses['edition'])){
		$edition_key = $licenses['edition']['key'];
		if(isset($_POST[$edition_key . '_wpas_license_activate']) && (empty($license_status[$edition_key]) || (!empty($license_status[$edition_key]) && $license_status[$edition_key]['status'] != 'valid'))){
			$license_action = "activate";
			$mylicense['name'] = $licenses['edition']['name'];
			$mylicense['key'] = $edition_key;
		} elseif(isset($_POST[$edition_key . '_wpas_license_deactivate']) && !empty($license_status[$edition_key]) && $license_status[$edition_key]['status'] != 'deactivated'){
			$license_action = "deactivate";
			$mylicense['name'] = $licenses['edition']['name'];
			$mylicense['key'] = $edition_key;
		}
	}
	if(empty($license_action) && !empty($licenses) && !empty($licenses['connection'])){
                foreach($licenses['connection'] as $key => $val){
                        if(isset($_POST[$val['key'] . '_wpas_license_activate']) && (empty($license_status[$val['key']]) || (!empty($license_status[$val['key']]) && $license_status[$val['key']]['status'] != 'valid'))){
                                $license_action = "activate";
				$mylicense['name'] = $val['name'];
				$mylicense['key'] = $val['key'];
                                break;
                        } elseif(isset($_POST[$val['key'] . '_wpas_license_deactivate']) && !empty($license_status[$val['key']]) && $license_status[$val['key']]['status'] != 'deactivated'){
                                $license_action = "deactivate";
				$mylicense['name'] = $val['name'];
				$mylicense['key'] = $val['key'];
                                break;
                        }
                }
        }
	if (!empty($license_action)) {
                // run a quick security check
                if (!check_admin_referer($mylicense['key'] . '_wpas_license_nonce', $mylicense['key'] . '_wpas_license_nonce')) return;
                // data to send in our API request
                $api_params = array(
                                'edd_action' => $license_action . '_license',
                                'license' => $mylicense['key'],
                                'item_name' => urlencode($edition_conn_list[$mylicense['name']]) , // the name of product
                                'url' => home_url()
                                );
                // Call the custom API.
                $response = wp_remote_post(WPAS_URL, array(
                                        'timeout' => 15,
                                        'sslverify' => false,
					'body' => $api_params
                                        ));

		$saved_error = get_option('wpas_license_error',Array());
                // make sure the response came back okay
                if (is_wp_error($response) || 200 !== wp_remote_retrieve_response_code($response)) {
			if(is_wp_error($response)) {
                                $error = $response->get_error_message();
                        } else {
                                $error = __('An error occurred, please try again.','wp-app-studio');
                        }
			$saved_error[$mylicense['key']] = $error;
                        update_option('wpas_license_error', $saved_error);
                        return false;
                }
                $license_data = json_decode(wp_remote_retrieve_body($response));
		if($license_action == 'activate' && false === $license_data->success) {
			switch($license_data->error) {
				case 'expired':
					$error = sprintf(
						__('Your license key expired on %s.','wp-app-studio'),
						date_i18n(get_option('date_format'), strtotime($license_data->expires, current_time('timestamp')))
					);
					break;
				case 'revoked':
					$error = __('Your license key has been disabled.','wp-app-studio');
					break;
				case 'missing':
					$error = __('Invalid license key.','wp-app-studio');
					break;
				case 'invalid':
				case 'site_inactive':
					$error = __('Your license key is not active for this URL.','wp-app-studio');
					break;
				case 'item_name_mismatch':
					$error = sprintf(__('This appears to be an invalid license key for %s.','wp-app-studio'), $edition_conn_list[$mylicense['name']]);
					break;
				case 'no_activations_left':
					$error = __('Your license key has reached its activation limit.','wp-app-studio');
					break;
				default :
					$error = __('We were unable to activate your license. Please check your license key and try again. If your license key is correct, please open a support ticket.','wp-app-studio');
					break;
			}
			$saved_error[$mylicense['key']] = $error;
			update_option('wpas_license_error', $saved_error);
			return false;
		}
		elseif($license_action == 'deactivate' && false === $license_data->success){
			$error = __('We were unable to deactivate your license. Please check your license key and try again. If your license key is correct, please open a support ticket.','wp-app-studio');
			$saved_error[$mylicense['key']] = $error;
			update_option('wpas_license_error', $saved_error);
			return false;
		}
		unset($saved_error[$mylicense['key']]);
		update_option('wpas_license_error', $saved_error);
		if(array_key_exists($mylicense['name'],$edition_list)){
			$license_status[$mylicense['key']]['type'] = 'edition';
		}
		elseif(array_key_exists($mylicense['name'],$conn_list)){
			$license_status[$mylicense['key']]['type'] = 'conn';
		}
                // decode the license data
		if ($license_action == 'activate') {
			$license_status[$mylicense['key']]['status'] = $license_data->license;
			$license_status[$mylicense['key']]['name'] = $mylicense['name'];
			update_option('wpas_license_status',$license_status);
                } elseif ($license_action == 'deactivate' && $license_data->license == 'deactivated') {
			$license_status[$mylicense['key']]['status'] = $license_data->license;
			$license_status[$mylicense['key']]['name'] = $mylicense['name'];
			update_option('wpas_license_status',$license_status);
                }
        }
}
